<?php
/**
 *
 * This is an extended version of the default
 * visual composer row element.
 *
 * More info:
 * http://kb.wpbakery.com/index.php?title=Vc_add_param
 * http://kb.wpbakery.com/index.php?title=Vc_map_update
 *
 * @since Orbit 1.2
 */
$output = $el_class = $bg_image = $bg_color = $bg_image_repeat = $font_color = $padding = $margin_bottom = $css = $orbit_row_activate = $orbit_row_bgcolor = $orbit_row_bgimage = $orbit_row_bgattachment = $orbit_row_bgposition = $orbit_row_bgimage_repeat = $custom_css_class = $unique_id = '';
extract(shortcode_atts(array(
    'el_class'        => '',
    'bg_image'        => '',
    'bg_color'        => '',
    'bg_image_repeat' => '',
    'font_color'      => '',
    'padding'         => '',
    'margin_bottom'   => '',
    'css' => '',
    /*new elements added by Orbit plugin*/
    'orbit_row_activate'           => '',
    'orbit_row_bgcolor'            => '',
    'orbit_row_bgimage'            => '',
    'orbit_row_bgattachment'       => '',
    'orbit_row_bgposition'         => '',
    'orbit_row_bgimage_repeat'     => '',
    'orbit_row_padding_vertical'   => '',
    'orbit_row_padding_horizontal' => '',
    'custom_css_class'             => '',
    'unique_id'                    => '',
    'content_container'			   => '',
    'orbit_parallax_activate'      => '',
    'orbit_parallax_scroll_speed'  => ''
), $atts));

wp_enqueue_script( 'wpb_composer_front_js' ); //do not remove - default VC stuff

//extract content_container raw html code.
$content_container = rawurldecode( base64_decode( $content_container ) );


// Check if Orbit Row is activated
if ($orbit_row_activate == 'orbit_row_active') {

	// Generate Unique ID to be used for styling
	$unique_id = orbit_truethemes_random();

	// $css_class is modified version of default VC stuff
	$css_class = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, ''.$unique_id.' orbit-layout-row '.$custom_css_class.' vc_row wpb_row '. ( $this->settings('base')==='vc_row_inner' ? 'vc_inner ' : '' ) . get_row_css_class() , $this->settings['base'], $atts );
	
	// Check for Parallax
	if($orbit_parallax_activate == 'orbit_parallax_active'){
        
        $output .= '<div class="'.$css_class.' orbit-parallax-active" data-type="background" data-speed="'.$orbit_parallax_scroll_speed.'">';
	
    } else {

		//no parallax
		$output .= '<div class="'.$css_class.'">';
	}

    // Remaining output for the row
    // Check for "content container" added by user
    if($content_container !=''){
        $content_container_wrapper = explode('%content%',$content_container);
        $output .= $content_container_wrapper[0];
        $output .= wpb_js_remove_wpautop($content);
        $output .= $content_container_wrapper[1].'</div>'.$this->endBlockComment('row');

    } else {

    // no content container
    $output .= wpb_js_remove_wpautop($content);
    $output .= '</div>'.$this->endBlockComment('row'); 

    } 

    // Create background stuff
   $orbit_row_bgimage_url = wp_get_attachment_image_src( $orbit_row_bgimage, $size = 'full'); //get image src using the attachment id
    if(!empty($orbit_row_bgimage)) {
        $orbit_bgimage_output = "background: $orbit_row_bgcolor url('$orbit_row_bgimage_url[0]') $orbit_row_bgimage_repeat fixed $orbit_row_bgposition;";
    };
    
    // Dynamic CSS Function $orbit_row_bgimage
    $style_code ='.vc_row.wpb_row.orbit-layout-row.'.$unique_id.' {
        background-color:'.$orbit_row_bgcolor.';
        padding: '.$orbit_row_padding_vertical.' '.$orbit_row_padding_horizontal.';
        '.$orbit_bgimage_output.'
        background-size: 100%;
    }';

	/**
	 *
	 * orbit dynamic CSS function
	 * slightly modified to work outside of orbit.php
	 *
	 * @since Orbit 1.2
	 */
	global $orbit_css_array;
    if(!in_array($style_code,$orbit_css_array)){
		array_push($orbit_css_array,$style_code);
    }

echo $output; //visual composer requires echo $output



} else { // orbit row is not actiavted, load default visual composer row

$el_class = $this->getExtraClass($el_class);
$css_class = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, 'vc_row wpb_row '. ( $this->settings('base')==='vc_row_inner' ? 'vc_inner ' : '' ) . get_row_css_class() . $el_class . vc_shortcode_custom_css_class( $css, ' ' ), $this->settings['base'], $atts );
$style = $this->buildStyle($bg_image, $bg_color, $bg_image_repeat, $font_color, $padding, $margin_bottom);

		$output .= '<div class="'.$css_class.'"'.$style.'>';
		$output .= wpb_js_remove_wpautop($content);
		$output .= '</div>'.$this->endBlockComment('row');

echo $output;

} // END check for orbit row